
// Look into using scrollRect instead of masks

package
{
	import flash.display.*;
	import flash.utils.*;
	
	public class Animation extends Sprite
	{
		public static var WIDTH : int = 16;
		public static var HEIGHT : int = 16;
		
		private var image : Bitmap;
		
		public var index : int = 0;
		public var frames : int;
		public var frameTime : int = 75;
		private var timer : int = 0;
		
		private var maskSprite : Sprite;
		
		public function Animation (_image: Bitmap, _frameTime: Number)
		{
			image = _image;
			
			frameTime = _frameTime;
			
			WIDTH = image.height;
			HEIGHT = WIDTH;
			
			maskSprite = new Sprite();
			maskSprite.graphics.beginFill(0xFF0000);
			maskSprite.graphics.drawRect(0, 0, WIDTH, HEIGHT);
			addChild(maskSprite);
			
			frames = image.width / WIDTH;
			
			image.mask = maskSprite;
			
			addChild(image);
		}
		
		public function dead () : Boolean { return false; }
		
		public function setFrame (id : int) : void
		{
			index = id;
			
			image.x = -index * WIDTH;
		}
		
		public function update (dt : int) : void
		{
			timer += dt;
			
			while (timer >= frameTime)
			{
				timer -= frameTime;
				setFrame((index + 1) % frames);
			}
		}
	}
}

