package
{
	import flash.display.*;
	import flash.events.*;
	
	public class Input
	{
		private static var keyboard : Object = new Object();
		
		public static var isMouseDown : Boolean;
		
		public static function attach (dispObj : DisplayObject) : void
		{
			dispObj.addEventListener( KeyboardEvent.KEY_DOWN, keyDownListener, false, 0, true );
			dispObj.addEventListener( KeyboardEvent.KEY_UP, keyUpListener, false, 0, true );
			dispObj.addEventListener( Event.ACTIVATE, activateListener, false, 0, true );
			dispObj.addEventListener( Event.DEACTIVATE, deactivateListener, false, 0, true );
			dispObj.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			dispObj.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
		}
		
		private static function keyDownListener( ev:KeyboardEvent ):void
		{
			keyboard[ev.keyCode] = true;
		}
		
		private static function keyUpListener( ev:KeyboardEvent ):void
		{
			keyboard[ev.keyCode] = false;
		}
		
		private static function activateListener( ev:Event ):void
		{
			keyboard = new Object();
		}

		private static function deactivateListener( ev:Event ):void
		{
			keyboard = new Object();
		}
		
		public static function keyPressed (key : uint) : Boolean
		{
			return keyboard[key];
		}
		
		public static function onMouseDown(e:MouseEvent):void
		{
			isMouseDown = true;
		}
		
		public static function onMouseUp(e:MouseEvent):void
		{
			isMouseDown = false;
		}
		
	}
}

