package
{
	import flash.display.*;
	import flash.utils.*;
	import flash.geom.*;
	
	public class Tile extends Sprite
	{
		public static const WIDTH : int = 16;
		public static const HEIGHT : int = 16;
		
		public static const EMPTY : int = 0;
		public static const PLAYER : int = 10;
		public static const EXIT : int = 11;
		public static const SPIKES : int = 12;
		public static const SPIKES2 : int = 5;
		public static const MAX : int = 12;
		
		[Embed(source="images/deserttiles.png")]
		public static var tileImageDesertSrc : Class;
		
		[Embed(source="images/icetiles.png")]
		public static var tileImageIceSrc : Class;
		
		public static var tileBitmapData : Array;
		public static var tileBitmapDataDesert : Array;
		public static var tileBitmapDataIce : Array;
		
		public var tileID : int;
		
		public function Tile (i : int)
		{
			tileID = i;
		}
		
		public function getAABB () : Rectangle
		{
			return new Rectangle(x, y, WIDTH, HEIGHT);
		}
		
		public function update (dt : int) : void {}
		
		public static function initTiles () : void
		{
			tileBitmapDataDesert = new Array();
			tileBitmapDataIce = new Array();
			
			var allDesertTiles : BitmapData = new tileImageDesertSrc().bitmapData;
			var allIceTiles : BitmapData = new tileImageIceSrc().bitmapData;
			
			var count : int = allIceTiles.width / WIDTH;
			
			var rect : Rectangle = new Rectangle(0, 0, WIDTH, HEIGHT);
			
			var topleft : Point = new Point(0, 0);
			
			for (var i : int = 0; i < count; i++)
			{
				tileBitmapDataDesert[i] = new BitmapData(WIDTH, HEIGHT);
				tileBitmapDataIce[i] = new BitmapData(WIDTH, HEIGHT);
				
				rect.x = i * WIDTH;
				
				tileBitmapDataDesert[i].copyPixels(allDesertTiles, rect, topleft);
				tileBitmapDataIce[i].copyPixels(allIceTiles, rect, topleft);
			}
			
			tileBitmapData = tileBitmapDataIce;
		}
		
		public static function swapTheme (): void
		{
			if (tileBitmapData == tileBitmapDataDesert) {
				tileBitmapData = tileBitmapDataIce;
			} else {
				tileBitmapData = tileBitmapDataDesert;
			}
		}

		public static function create (id : *) : Tile
		{
			var index : int;
			
			if (id is String) {
				index = parseInt(id);
			} else {
				index = id;
			}
			
			if (index == 0) { return null; }
			
			switch (index) {
				case PLAYER:
				case EXIT:
					return new SpawnTile(index);
				default:
					return new StaticTile(index);
			}
		}
	}
}

